From: Denis Pynkin <denis.pynkin@collabora.com>
Date: Sun, 16 Feb 2020 21:08:35 +0300
Subject: i.mx6 HAB: disable boot with bootelf and bootvx commands

Do not allow application execution command on closed devices.
Setting the check on elf verification code successfully preventing
the boot of elf-based binaries (used in `bootelf` and `bootvx`).

Signed-off-by: Denis Pynkin <denis.pynkin@collabora.com>
---
 lib/elf.c | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

diff --git a/lib/elf.c b/lib/elf.c
index d074e4e..fe65564 100644
--- a/lib/elf.c
+++ b/lib/elf.c
@@ -16,6 +16,11 @@
 #include <linux/linkage.h>
 #endif
 
+#if defined(CONFIG_ARCH_MX6) && defined(CONFIG_IMX_HAB)
+#include <asm/mach-imx/hab.h>
+#include <hang.h>
+#endif
+
 /*
  * A very simple ELF64 loader, assumes the image is valid, returns the
  * entry point address.
@@ -230,6 +235,15 @@ int valid_elf_image(unsigned long addr)
 {
 	Elf32_Ehdr *ehdr; /* Elf header structure pointer */
 
+#if defined(CONFIG_ARCH_MX6) && defined(CONFIG_IMX_HAB)
+	/* Prevent the boot on closed devices */
+	if (imx_hab_is_enabled())
+	{
+		printf("i.MX HAB: prohibited on closed devices\n");
+		hang();
+	}
+#endif
+
 	ehdr = (Elf32_Ehdr *)addr;
 
 	if (!IS_ELF(*ehdr)) {
